"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const Path = tslib_1.__importStar(require("path"));
const core_1 = require("@magicspace/core");
const clime_1 = require("clime");
const FSExtra = tslib_1.__importStar(require("fs-extra"));
const _command_1 = require("../@command");
const _constants_1 = require("../@constants");
let default_1 = class default_1 extends clime_1.Command {
    async execute(projectDir, options) {
        const magicspaceDir = Path.resolve(projectDir, options.magicspace);
        const { module: configExport } = await (0, core_1.resolveMagicspaceBoilerplateConfig)(magicspaceDir);
        if (Array.isArray(configExport)) {
            throw new clime_1.ExpectedError('JSON schema update is not supported for multi-boilerplate config');
        }
        const { boilerplate } = configExport;
        const { Options } = await (0, core_1.resolveBoilerplateModule)(boilerplate, magicspaceDir);
        if (Options) {
            const configSchemaPath = Path.join(magicspaceDir, _constants_1.CONFIG_SCHEMA_FILE_NAME);
            await FSExtra.outputFile(configSchemaPath, JSON.stringify((0, core_1.buildConfigSchema)(Options), undefined, 2));
            return 'JSON schema updated.';
        }
        else {
            return `Options X-Type is not defined for boilerplate ${JSON.stringify(boilerplate)}`;
        }
    }
};
tslib_1.__decorate([
    clime_1.metadata,
    tslib_1.__param(0, (0, clime_1.param)({
        default: '.',
    })),
    tslib_1.__metadata("design:type", Function),
    tslib_1.__metadata("design:paramtypes", [String, _command_1.CommonOptions]),
    tslib_1.__metadata("design:returntype", Promise)
], default_1.prototype, "execute", null);
default_1 = tslib_1.__decorate([
    (0, clime_1.command)({
        description: 'Update magicspace config schema',
    })
], default_1);
exports.default = default_1;
//# sourceMappingURL=update-schema.js.map